# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['GroupArgs', 'Group']

@pulumi.input_type
class GroupArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 default_project_role: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Group resource.
        :param pulumi.Input[str] name: The name of the group
        :param pulumi.Input[str] default_project_role: The default project role assigned to the group when added to a Doppler project
        """
        pulumi.set(__self__, "name", name)
        if default_project_role is not None:
            pulumi.set(__self__, "default_project_role", default_project_role)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The name of the group
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="defaultProjectRole")
    def default_project_role(self) -> Optional[pulumi.Input[str]]:
        """
        The default project role assigned to the group when added to a Doppler project
        """
        return pulumi.get(self, "default_project_role")

    @default_project_role.setter
    def default_project_role(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_project_role", value)


@pulumi.input_type
class _GroupState:
    def __init__(__self__, *,
                 default_project_role: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 slug: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Group resources.
        :param pulumi.Input[str] default_project_role: The default project role assigned to the group when added to a Doppler project
        :param pulumi.Input[str] name: The name of the group
        :param pulumi.Input[str] slug: The slug of the group
        """
        if default_project_role is not None:
            pulumi.set(__self__, "default_project_role", default_project_role)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if slug is not None:
            pulumi.set(__self__, "slug", slug)

    @property
    @pulumi.getter(name="defaultProjectRole")
    def default_project_role(self) -> Optional[pulumi.Input[str]]:
        """
        The default project role assigned to the group when added to a Doppler project
        """
        return pulumi.get(self, "default_project_role")

    @default_project_role.setter
    def default_project_role(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_project_role", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the group
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def slug(self) -> Optional[pulumi.Input[str]]:
        """
        The slug of the group
        """
        return pulumi.get(self, "slug")

    @slug.setter
    def slug(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "slug", value)


class Group(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 default_project_role: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manage a Doppler group.

        ## Example Usage

        ```python
        import pulumi
        import pulumiverse_doppler as doppler

        engineering = doppler.Group("engineering", name="engineering")
        ```

        ## Import

        import using the group slug from the URL:

        https://dashboard.doppler.com/workplace/[workplace-slug]/team/groups/[group-slug]

        ```sh
        $ pulumi import doppler:index/group:Group default <group-slug>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] default_project_role: The default project role assigned to the group when added to a Doppler project
        :param pulumi.Input[str] name: The name of the group
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manage a Doppler group.

        ## Example Usage

        ```python
        import pulumi
        import pulumiverse_doppler as doppler

        engineering = doppler.Group("engineering", name="engineering")
        ```

        ## Import

        import using the group slug from the URL:

        https://dashboard.doppler.com/workplace/[workplace-slug]/team/groups/[group-slug]

        ```sh
        $ pulumi import doppler:index/group:Group default <group-slug>
        ```

        :param str resource_name: The name of the resource.
        :param GroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 default_project_role: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GroupArgs.__new__(GroupArgs)

            __props__.__dict__["default_project_role"] = default_project_role
            if name is None and not opts.urn:
                raise TypeError("Missing required property 'name'")
            __props__.__dict__["name"] = name
            __props__.__dict__["slug"] = None
        super(Group, __self__).__init__(
            'doppler:index/group:Group',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            default_project_role: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            slug: Optional[pulumi.Input[str]] = None) -> 'Group':
        """
        Get an existing Group resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] default_project_role: The default project role assigned to the group when added to a Doppler project
        :param pulumi.Input[str] name: The name of the group
        :param pulumi.Input[str] slug: The slug of the group
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GroupState.__new__(_GroupState)

        __props__.__dict__["default_project_role"] = default_project_role
        __props__.__dict__["name"] = name
        __props__.__dict__["slug"] = slug
        return Group(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="defaultProjectRole")
    def default_project_role(self) -> pulumi.Output[Optional[str]]:
        """
        The default project role assigned to the group when added to a Doppler project
        """
        return pulumi.get(self, "default_project_role")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the group
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def slug(self) -> pulumi.Output[str]:
        """
        The slug of the group
        """
        return pulumi.get(self, "slug")

