# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['GroupArgs', 'Group']

@pulumi.input_type
class GroupArgs:
    def __init__(__self__, *,
                 group_slug: pulumi.Input[str],
                 project: pulumi.Input[str],
                 role: pulumi.Input[str],
                 environments: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a Group resource.
        :param pulumi.Input[str] group_slug: The slug of the Doppler group
        :param pulumi.Input[str] project: The name of the Doppler project where the access is applied
        :param pulumi.Input[str] role: The project role identifier for the access
        :param pulumi.Input[Sequence[pulumi.Input[str]]] environments: The environments in the project where this access will apply (null or omitted for roles with access to all environments)
        """
        pulumi.set(__self__, "group_slug", group_slug)
        pulumi.set(__self__, "project", project)
        pulumi.set(__self__, "role", role)
        if environments is not None:
            pulumi.set(__self__, "environments", environments)

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> pulumi.Input[str]:
        """
        The slug of the Doppler group
        """
        return pulumi.get(self, "group_slug")

    @group_slug.setter
    def group_slug(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_slug", value)

    @property
    @pulumi.getter
    def project(self) -> pulumi.Input[str]:
        """
        The name of the Doppler project where the access is applied
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: pulumi.Input[str]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter
    def role(self) -> pulumi.Input[str]:
        """
        The project role identifier for the access
        """
        return pulumi.get(self, "role")

    @role.setter
    def role(self, value: pulumi.Input[str]):
        pulumi.set(self, "role", value)

    @property
    @pulumi.getter
    def environments(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The environments in the project where this access will apply (null or omitted for roles with access to all environments)
        """
        return pulumi.get(self, "environments")

    @environments.setter
    def environments(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "environments", value)


@pulumi.input_type
class _GroupState:
    def __init__(__self__, *,
                 environments: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 role: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Group resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] environments: The environments in the project where this access will apply (null or omitted for roles with access to all environments)
        :param pulumi.Input[str] group_slug: The slug of the Doppler group
        :param pulumi.Input[str] project: The name of the Doppler project where the access is applied
        :param pulumi.Input[str] role: The project role identifier for the access
        """
        if environments is not None:
            pulumi.set(__self__, "environments", environments)
        if group_slug is not None:
            pulumi.set(__self__, "group_slug", group_slug)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if role is not None:
            pulumi.set(__self__, "role", role)

    @property
    @pulumi.getter
    def environments(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The environments in the project where this access will apply (null or omitted for roles with access to all environments)
        """
        return pulumi.get(self, "environments")

    @environments.setter
    def environments(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "environments", value)

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> Optional[pulumi.Input[str]]:
        """
        The slug of the Doppler group
        """
        return pulumi.get(self, "group_slug")

    @group_slug.setter
    def group_slug(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_slug", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Doppler project where the access is applied
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter
    def role(self) -> Optional[pulumi.Input[str]]:
        """
        The project role identifier for the access
        """
        return pulumi.get(self, "role")

    @role.setter
    def role(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role", value)


class Group(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 environments: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 role: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manage a Doppler project group member.

        ## Example Usage

        ```python
        import pulumi
        import pulumiverse_doppler as doppler

        backend_engineering = doppler.project_member.Group("backend_engineering",
            project="backend",
            group_slug=engineering["slug"],
            role="collaborator",
            environments=[
                "dev",
                "stg",
            ])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] environments: The environments in the project where this access will apply (null or omitted for roles with access to all environments)
        :param pulumi.Input[str] group_slug: The slug of the Doppler group
        :param pulumi.Input[str] project: The name of the Doppler project where the access is applied
        :param pulumi.Input[str] role: The project role identifier for the access
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manage a Doppler project group member.

        ## Example Usage

        ```python
        import pulumi
        import pulumiverse_doppler as doppler

        backend_engineering = doppler.project_member.Group("backend_engineering",
            project="backend",
            group_slug=engineering["slug"],
            role="collaborator",
            environments=[
                "dev",
                "stg",
            ])
        ```

        :param str resource_name: The name of the resource.
        :param GroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 environments: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 role: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GroupArgs.__new__(GroupArgs)

            __props__.__dict__["environments"] = environments
            if group_slug is None and not opts.urn:
                raise TypeError("Missing required property 'group_slug'")
            __props__.__dict__["group_slug"] = group_slug
            if project is None and not opts.urn:
                raise TypeError("Missing required property 'project'")
            __props__.__dict__["project"] = project
            if role is None and not opts.urn:
                raise TypeError("Missing required property 'role'")
            __props__.__dict__["role"] = role
        super(Group, __self__).__init__(
            'doppler:projectMember/group:Group',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            environments: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            group_slug: Optional[pulumi.Input[str]] = None,
            project: Optional[pulumi.Input[str]] = None,
            role: Optional[pulumi.Input[str]] = None) -> 'Group':
        """
        Get an existing Group resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] environments: The environments in the project where this access will apply (null or omitted for roles with access to all environments)
        :param pulumi.Input[str] group_slug: The slug of the Doppler group
        :param pulumi.Input[str] project: The name of the Doppler project where the access is applied
        :param pulumi.Input[str] role: The project role identifier for the access
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GroupState.__new__(_GroupState)

        __props__.__dict__["environments"] = environments
        __props__.__dict__["group_slug"] = group_slug
        __props__.__dict__["project"] = project
        __props__.__dict__["role"] = role
        return Group(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def environments(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The environments in the project where this access will apply (null or omitted for roles with access to all environments)
        """
        return pulumi.get(self, "environments")

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> pulumi.Output[str]:
        """
        The slug of the Doppler group
        """
        return pulumi.get(self, "group_slug")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output[str]:
        """
        The name of the Doppler project where the access is applied
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter
    def role(self) -> pulumi.Output[str]:
        """
        The project role identifier for the access
        """
        return pulumi.get(self, "role")

